//This would be a good example for when an ArrayList is needed
//Rather than a fixed size of maxNumCircles, we'd like an adjustable size array

int numCircles = 1; //to draw
int maxNumCircles = 5;
int [] xPos = new int[maxNumCircles];
int [] yPos = new int[maxNumCircles];

void setup()
{
  size(400, 400);
  
  for(int i = 0; i < maxNumCircles; i++)
  {
     xPos[i] = (int)random(width); 
     yPos[i] = (int)random(height); 
  }
}

void draw()
{
  background(0);
  
  for(int i = 0; i < numCircles; i++)
  {
    ellipse(xPos[i], yPos[i], 20, 20);
  }
}

void mouseClicked()
{
  if(numCircles < maxNumCircles)
   numCircles++; //numCircles = numCircles + 1
}