String [] names = {"Bob", "Tom", "Mary", "Jane"}; //Array Holds fixed number of items
//Adding a color array of equal length just to show that this is useful for more than name picking!
color [] colors = {color(255, 0, 0), color(0, 255, 0), color(0, 0, 255), color(255, 0, 255)};
ArrayList<Integer> picked = new ArrayList<Integer>(); //ArrayList holds variable number of items
int nameIndex;
boolean done = false;

void setup()
{
   size(400, 400);
   nameIndex = pickNew();
}

void draw()
{
  textSize(64); 
  if(!done)
  {
    background(colors[nameIndex]);
    text(names[nameIndex], 100, 200);
  }
  else
  {
    background(0);
    text("Done!", 100, 200);
  }
}

void mouseClicked()
{  
  if(picked.size() < names.length) //if we haven't picked all the names
    nameIndex = pickNew();
  else
    done = true;
}

int pickNew() //pick a new, non-repeating, index
{
  int newIndex = (int)random(names.length); //pick a new name
  boolean goodIndex = true; //assume it hasnt been picked before
  //check that it hasn't been picked before
  for(int i = 0; i < picked.size(); i++)
     if(newIndex == picked.get(i)) goodIndex = false;
  
  if(goodIndex)
  {
    picked.add(newIndex);
    return newIndex;
  }
  else
    return pickNew(); //try again
}